#!/usr/bin/perl -w

# Zap2it(tm) DataDirect(tm) Client with Parsing
# Author: JRB
# Last Modified: 2/14/2004 BY: THC
# Version: 2.0
#


use warnings;


#//////////////////////DEFAULT CONFIGURATION VARIABLES//////////////////////////////////////

our $username = "";
our $password = "";
our $num_of_days = 1;
our $wisdl_source = "";
our $compression = 1;

#///////////////////////////////////////////////////////////////////////////////////////////


my $tvtPath = `echo ~`;
$tvtPath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/xtvdData.xml/g;


### Process the properties file: xtvd.xml

my $config;
open(FILE, "< xtvd.xml");
while(<FILE>) {
	$config .= $_;
}
close(FILE);
#$username = $1 if ($config =~ m#<userName[^>]*>([^>]+)</userName>#s);
#$password = $1 if ($config =~ m#<password[^>]*>([^>]+)</password>#s);
$num_of_days = $1 if ($config =~ m#<numberOfDays[^>]*>([^>]+)</numberOfDays>#s);
$wisdl_source = $1 if ($config =~ m#<webserviceURI[^>]*>([^>]+)</webserviceURI>#s);
$compression = $1 if ($config =~ m#<compression[^>]*>([^>]+)</compression>#s);

#if ( $username =~ /^$/ || $password =~ /^$/ )
#{
#	print "Invalid username/password\n";
#	exit;
#}

### Time calculation
#our $start = &getDate(time(), 0);
#our $start = &getDate(time(), 0);
#our $end = &getDate(time(), $num_of_days);


$username = $ARGV[0];
$password = $ARGV[1];
our $start = $ARGV[2];
our $end = $ARGV[3];

print $start."\n";
print $end."\n";


print "username: ",$username,"\n";
print "password: ",$password,"\n";
print "start date-time: ",$start,"\n";
print "end date-time: ",$end,"\n";


sub getDate()
{
	my $start_time = $_[0];
	my $days = $_[1];
	my $time_value = ${start_time}+${days}*60*60*24;
	my ($sec, $min, $hour, $date, $mon, $year, $wday, $yday) = gmtime($time_value);
	gmtime($time_value) =~ /(\S*)\s*(\S*)\s*(\S*)\s*(\S*)\s*(\S*)/;
	my $DATE = $3;
	$DATE = "0".$DATE if ($DATE < 10);
	my $TIME = $4;
	my $YEAR = $5;

	my $MONTH = $mon+1;
	$MONTH = "0".$MONTH if ($MONTH < 10);

	return "$YEAR-$MONTH-$DATE"."T"."$TIME"."Z";
}



### Set username/password for HTTP Digest

sub SOAP::Transport::HTTP::Client::get_basic_credentials {
    return "$username" => "$password";
  }

### Build SOAP object
our ($soapenv, $xtvddoc);
use SOAP::Lite;

$soapenv = SOAP::Lite
 -> service($wisdl_source)
 -> outputxml('true')
 -> on_fault( sub {
	my($soap,$res)=@_;
	print "SOAP call failed: ".
	(ref $res ? $res->faultstring : $soap->transport->status)."\n";
	exit 1;
	} );

if ($compression)
{
	$xtvddoc = $soapenv
	  -> proxy('http://foobar/', options => {compress_threshold => 10000}, timeout => 420)
	  -> download("<startTime>$start</startTime><endTime>$end</endTime>")
}
else
{
	$xtvddoc = $soapenv
	  -> proxy('http://foobar/', timeout => 420)
	  -> download("<startTime>$start</startTime><endTime>$end</endTime>")
}

&parseXTVD();


sub parseXTVD()
{
	my $secs = time;
	if ($xtvddoc =~ m#(<xtvd\s.*</xtvd>)#s)
	{
		open(XTVDFILE, ">$tvtPath");
		print XTVDFILE $1;
		close(XTVDFILE);
		if ($xtvddoc =~ m#<messages[^>]*>(.+)</messages>#s)
		{
			my $tmp = $1;
			$tmp =~ s/<[^>]+>/\n/g;
			print $tmp;
		}
		print "XTVD data is saved as xtvdData.xml\n";
&parseMore();
	} else {
		print "\nERROR PROCESSING REQUEST: \n";
		print $xtvddoc,"\n";
	}
}

sub parseMore()
{
	
	my $tvtPath = `echo ~`;
	my $titlesPath = `echo ~`;
	my $timePath = `echo ~`;
	my $showDataPath = `echo ~`;
	my $schedulePath = `echo ~`;
	my $channelsPath = `echo ~`;
	my $lineupsPath = `echo ~`;

	$tvtPath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/xtvdData.xml/g;
	$titlesPath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/titles.txt/g;
	$timePath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/time.txt/g;
	$showDataPath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/showData.txt/g;
	$schedulePath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/schedule.txt/g;
	$lineupsPath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/lineups.txt/g;
	$channelsPath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\//g;

	@channels2 = `cat "$tvtPath" | grep "map station" | grep -v "channelMinor"`;

	#@lineups = split(/\/lineup/, $stationsString);
	$lineupName = `cat "$tvtPath"`;
	$lineupName =~ tr/\n/;/;
	$lineupName =~ m/lineups...(.*?)....lineups/;
	$lineupString = $1;




	@splitLineups = split(/\/lineup/, $lineupString);
	#print $splitLineups[1];
	my $channelPathEnding;

	open(DAT2,">$lineupsPath");
	foreach(@splitLineups) {

		$l = $_;

		#print $l."\n\n\n\n";
		$lineupString2 = "";
		if ($l =~ m/id='(.*?)'/){

			$channelPathEnding = $1;
			if ($channelPathEnding =~ m/(.*):(.*)/){
				$channelPathEnding = $1;
			}

			$lineupString2 = $1."|";
			$channelPathEnding = $channelPathEnding."Channels.txt"
			#$channelPathEnding = "Channels.txt";
		}

		if ($l =~ m/name='(.*?)'/){
			$lineupString2 = $lineupString2.$1."|";
		}

		if ($l =~ m/location='(.*?)'/){
			$lineupString2 = $lineupString2.$1."|";
		}
		
		if ($l =~ m/postalCode='(.*?)'/){
			$lineupString2 = $lineupString2.$1."|";
		}

		if ($l =~ m/type='(.*?)'/){
			$lineupString2 = $lineupString2.$1."||";
		}
		print DAT2 $lineupString2."\n";

		$l =~ tr/;/\n/;
		@channels = `echo "$l" | grep "map station" | grep -v "channelMinor"`;
	#	print @channels;
		$stationName = `cat "$tvtPath"`;



		#my $a;
		#my @b;
		$stationName =~ tr/\n/;/;
		$stationName =~ m/(stations.*?stations)/;
		$stationsString = $1;

		my @fullChannelList;
		my $counter = 0;

		@splitStations = split(/\/station/, $stationsString);

		foreach(@splitStations) {
			$c = $_;
			if ($c =~ m/<station id=\'(.+)\'>;<callSign>(.+)<\/callSign>;<name>(.+)<\/name>/)
			{	
				#print $chanId." ".$1."\n\n";
				$tempID = $1;
				if (index($l, $1) != -1) {		
					$chanId = getChannelNumber($1);
					if ($chanId != -1) {
						$fullChannelList[$counter] = [$chanId, $1, $2, $3];
						#print $chanId."\n";
						$counter++;
					}
				}
			}

		}

		#write the list to channels.txt;

		open(DAT,">$channelsPath$channelPathEnding");
		for $list_ref ( sort { $a->[0] <=> $b->[0] } @fullChannelList ) {
		    #print DAT "@$list_ref\n";
		    print DAT "$$list_ref[0]|$$list_ref[1]|$$list_ref[2]|$$list_ref[3]||\n";

		} 
		close(DAT);
	}

	close(DAT2);

	open(DAT,">$titlesPath");

	$titles = `cat "$tvtPath" | grep "<program id\\|<title>"`;

	$titles =~ s/<program id='(.+)'>\n<title>/$1<t>/g;
	$titles =~ s/<\/title>//g;
	print DAT $titles;
	close(DAT);

	@titleSplit = split(/\n/, $titles);

	my %titleHash;

	foreach(@titleSplit){
		if ($_ =~ m/(.*)<t>(.*)/){
			$titleHash{$1} = $2;
		}
	}




	open(DAT,">$schedulePath");

	@schedules = `cat "$tvtPath" | grep "schedule program"`;
	foreach (@schedules) {
		$ts = $_;
		$ending = "";
		#make the repeat and hdtv strings
		if ($ts =~ m/repeat='false'/){
			$ending = $ending . "|true";
		} else {
			$ending = $ending . "|false";
		}

		if ($ts =~ m/hdtv='true'/){
			$ending = $ending . "|true";
		} else {
			$ending = $ending . "|false";
		}

		if ($ts =~ m/<schedule program='(.+)' station='(.+)' time='(.+)' duration='(.*?)'/){

			$temp = "$1|$2|$3|$4|".getTitle($1).$ending."||\n";
			$temp =~ s/(\d\d\d\d)-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d)Z/$1-$2-$3-$4-$5-$6/g;
			#print $temp;
			print DAT $temp;

			#print DAT ("$1|$2|$3|$4|".getTitle($1)."||\n");
		} else {print("AA\n")}
		#print($_);
	}

	close(DAT);

	open(DAT,">$timePath");
	$time = `grep "<xtvd from.*schemaVersion" "$tvtPath"`;
	#print $time;
	#<xtvd from='2006-01-05T01:56:50Z' to='2006-01-06T01:56:50Z' schemaVersion='1.3'

	if ($time =~ m/<xtvd from=.(\d\d\d\d)-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d)Z. to=.(\d\d\d\d)-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d)\.*/) {
		print DAT "$1-$2-$3-$4-$5-$6\n$7-$8-$9-$10-$11-$12\n";
	}
	close DAT;

	#need to make the file containing the specific data for the show;

	#<program id='EP0349100214'>
	#<title>ComicView</title>
	#<description>Damon Williams; Darius Bradford; Darryl Damn; Derrick Ellis; Lil&apos; DuVall.</description>
	#<showType>Series</showType>
	#<series>SH034910</series>
	#<syndicatedEpisodeNumber>425</syndicatedEpisodeNumber>
	#<originalAirDate>2005-12-23</originalAirDate>
	#</program>

	$programsLong = `cat "$tvtPath"`;
	$programsLong =~ s/\n/;/g;
	$programsLong =~ m/(<programs>.*<\/programs>)/;
	$programsLong2 = $1;
	#print $programsLong2;

	@splitPrograms = split(/<\/program>/, $programsLong2);

	#print "$programsLong";


	open(DAT,">$showDataPath");
	foreach(@splitPrograms) {
		$showDataKey = "";
		$showDataString = "";

		$tempProgram = $_;

		#check for title
	#	if ($tempProgram =~ m/<program id='(.*)'>;<title>(.*)<\/title>;<subtitle>(.*)<\/subtitle>;<description>(.*)<\/description>/) {
		if ($tempProgram =~ m/(.*)<program id='(.*)'>;/) {
			$showDataKey = $showDataKey . "p";
			$showDataString = $showDataString . $2 . "|";
		} else {
			$showDataKey = $showDataKey . "0";
			$showDataString = $showDataString . "|";
		}
		if ($tempProgram =~ m/(.*)<title>(.*)<\/title>(.*)/) {
			$showDataKey = $showDataKey . "1";
			$showDataString = $showDataString . $2 . "|";
		} else {
			$showDataKey = $showDataKey . "0";
			$showDataString = $showDataString . "|";
		}

		if ($tempProgram =~ m/(.*)<subtitle>(.*)<\/subtitle>(.*)/) {
			$showDataKey = $showDataKey . "1";
			$showDataString = $showDataString . $2 . "|";
		} else {
			$showDataKey = $showDataKey . "0";
			$showDataString = $showDataString . "|";
		}

		if ($tempProgram =~ m/(.*)<description>(.*)<\/description>(.*)/) {
			$showDataKey = $showDataKey . "1";
			$showDataString = $showDataString . $2 . "|";
		} else {
			$showDataKey = $showDataKey . "0";
			$showDataString = $showDataString . "|";
		}

		print DAT "$showDataKey|$showDataString-||||||||||\n";

	#	if ($tempProgram =~ m/<program id='(.*)'>;<title>(.*)<\/title>;<subtitle>(.*)<\/subtitle>;<description>(.*)<\/description>/) {
	#		print DAT "ptsd|$1|$2|$3|$4\n";
			#we have ptsd
	#	} else {
	#			if ($tempProgram =~ m/<program id='(.*)'>;<title>(.*)<\/title>;<subtitle>(.*)<\/subtitle>/) {
					#we have pts
					#print("pts\n");
	#				print DAT "ptsx|$1|$2|$3|none\n";

	#			} else {	
	#			if ($tempProgram =~ m/<program id='(.*)'>;<title>(.*)<\/title>;<description>(.*)<\/description>/) {
					#we have ptd			
					#print("ptd\n");
	#				print DAT "ptxd|$1|$2|none|$3\n";
	#			} else {
	#				if ($tempProgram =~ m/<program id='(.*)'>;<title>(.*)<\/title>/) { 
						#we just have pt
	#					print DAT "ptxx|$1|$2|none|none\n";
						#print("pt\n");
	#				} else {

						#FAILURE
	#				}			
	#			}
	#		}
	#	}
	}

	close DAT;
}

sub getTitle {
	#$fullLine = `cat titles.txt | grep $_[0]`;
	#if ($fullLine =~ m/(.*)<t>(.+)\n/){
	#	return $2;
	
	#}
	#return $fullLine;
	return $titleHash{$_[0]};
}

sub getChannelNumber {
  $channelId = $_[0];
  foreach(@channels2) {
	$test = $_;	

  	if ($test =~ m/(\d+)(\D+)(\d+)/g) {
		if ($1 == $channelId) {
						
			return $3;
		}
	}
  }
  return -1;
}
__END__

=head1 NAME

datadirect-parse.pl - a sample PERL script to download an XTVD document of personalized television listings from Zap2it(tm) Data Direct's web service.

=head1 DESCRIPTION

This script is designed to be a fully operable client to demonstrate how to access Data Direct using PERL's SOAP::Lite package and includes parsing functionality to extract the xtvd document separately from the messages.

=head1 REQUIREMENTS

You need to have the following packages loaded onto your system before this script will run:

SOAP::Lite [tested on v1.47]

You also need to have established a subscription and selected your station lineup via the Data Direct website (http://labs.zap2it.com/)

=head1 INSTALLATION

Set the variables at the top of the script for your chosen username and password (the same as for your subscription).

=head1 USAGE

Run the script, and the XTVD document containing your desired listings will be output to a uniquely named file, according to the XTVD schema. Any messages from the DataDirect service will go to standard output.

=head1 COPYRIGHT AND DISCLAIMER

This program is Copyright 2003 by Tribune Media Services, Inc.  This program is free software; you can redistribute it and/or
modify it under the terms of the Perl Artistic License or the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

If you do not have a copy of the GNU General Public License write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
