#!/usr/bin/perl -W

my $tvtPath = `echo ~`;
my $titlesPath = `echo ~`;
my $timePath = `echo ~`;
my $showDataPath = `echo ~`;
my $schedulePath = `echo ~`;
my $channelsPath = `echo ~`;


$tvtPath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/xtvdData.xml/g;
$titlesPath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/titles.txt/g;
$timePath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/time.txt/g;
$showDataPath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/showData.txt/g;
$schedulePath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/schedule.txt/g;
$channelsPath =~ s/\n/\/Library\/Application\ Support\/TV\ Tracker\/channels.txt/g;

@channels = `cat "$tvtPath" | grep "map station"`;

$stationName = `cat "$tvtPath"`;



#my $a;
#my @b;
$stationName =~ tr/\n/;/;
$stationName =~ m/(stations.*?stations)/;
$stationsString = $1;

my @fullChannelList;
my $counter = 0;

@splitStations = split(/\/station/, $stationsString);

foreach(@splitStations) {
	$c = $_;
	if ($c =~ m/<station id=\'(.+)\'>;<callSign>(.+)<\/callSign>;<name>(.+)<\/name>/)
	{	
		$chanId = getChannelNumber($1);
		$fullChannelList[$counter] = [$chanId, $1, $2, $3];
		$counter++;
	}

}

#write the list to channels.txt;
open(DAT,">$channelsPath");
for $list_ref ( sort { $a->[0] <=> $b->[0] } @fullChannelList ) {
    #print DAT "@$list_ref\n";
    print DAT "$$list_ref[0]|$$list_ref[1]|$$list_ref[2]|$$list_ref[3]||\n";
    
} 
close(DAT);

open(DAT,">$titlesPath");

$titles = `cat "$tvtPath" | grep "<program id\\|<title>"`;

$titles =~ s/<program id='(.+)'>\n<title>/$1<t>/g;
$titles =~ s/<\/title>//g;
print DAT $titles;
close(DAT);

@titleSplit = split(/\n/, $titles);

my %titleHash;

foreach(@titleSplit){
	if ($_ =~ m/(.*)<t>(.*)/){
		$titleHash{$1} = $2;
	}
}




open(DAT,">$schedulePath");
print DAT "hello\n";
@schedules = `cat "$tvtPath" | grep "schedule program"`;
foreach (@schedules) {
	$ts = $_;
	$ending = "";
	#make the repeat and hdtv strings
	if ($ts =~ m/repeat='false'/){
		$ending = $ending . "|true";
	} else {
		$ending = $ending . "|false";
	}

	if ($ts =~ m/hdtv='true'/){
		$ending = $ending . "|true";
	} else {
		$ending = $ending . "|false";
	}

	if ($ts =~ m/<schedule program='(.+)' station='(.+)' time='(.+)' duration='(.*?)'/){
		
		$temp = "$1|$2|$3|$4|".getTitle($1).$ending."||\n";
		$temp =~ s/(\d\d\d\d)-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d)Z/$1-$2-$3-$4-$5-$6/g;
		print $temp;
		print DAT $temp;
		
		#print DAT ("$1|$2|$3|$4|".getTitle($1)."||\n");
	} else {print("AA\n")}
	#print($_);
}

close(DAT);

open(DAT,">$timePath");
$time = `grep "<xtvd from.*schemaVersion" "$tvtPath"`;
#print $time;
#<xtvd from='2006-01-05T01:56:50Z' to='2006-01-06T01:56:50Z' schemaVersion='1.3'

if ($time =~ m/<xtvd from=.(\d\d\d\d)-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d)Z. to=.(\d\d\d\d)-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d)\.*/) {
	print DAT "$1-$2-$3-$4-$5-$6\n$7-$8-$9-$10-$11-$12\n";
}
close DAT;

#need to make the file containing the specific data for the show;

#<program id='EP0349100214'>
#<title>ComicView</title>
#<description>Damon Williams; Darius Bradford; Darryl Damn; Derrick Ellis; Lil&apos; DuVall.</description>
#<showType>Series</showType>
#<series>SH034910</series>
#<syndicatedEpisodeNumber>425</syndicatedEpisodeNumber>
#<originalAirDate>2005-12-23</originalAirDate>
#</program>

$programsLong = `cat "$tvtPath"`;
$programsLong =~ s/\n/;/g;
$programsLong =~ m/(<programs>.*<\/programs>)/;
$programsLong2 = $1;
#print $programsLong2;

@splitPrograms = split(/<\/program>/, $programsLong2);

#print "$programsLong";


open(DAT,">$showDataPath");
foreach(@splitPrograms) {
	$showDataKey = "";
	$showDataString = "";
	
	$tempProgram = $_;
	
	#check for title
#	if ($tempProgram =~ m/<program id='(.*)'>;<title>(.*)<\/title>;<subtitle>(.*)<\/subtitle>;<description>(.*)<\/description>/) {
	if ($tempProgram =~ m/(.*)<program id='(.*)'>;/) {
		$showDataKey = $showDataKey . "p";
		$showDataString = $showDataString . $2 . "|";
	} else {
		$showDataKey = $showDataKey . "0";
		$showDataString = $showDataString . "|";
	}
	if ($tempProgram =~ m/(.*)<title>(.*)<\/title>(.*)/) {
		$showDataKey = $showDataKey . "1";
		$showDataString = $showDataString . $2 . "|";
	} else {
		$showDataKey = $showDataKey . "0";
		$showDataString = $showDataString . "|";
	}

	if ($tempProgram =~ m/(.*)<subtitle>(.*)<\/subtitle>(.*)/) {
		$showDataKey = $showDataKey . "1";
		$showDataString = $showDataString . $2 . "|";
	} else {
		$showDataKey = $showDataKey . "0";
		$showDataString = $showDataString . "|";
	}
	
	if ($tempProgram =~ m/(.*)<description>(.*)<\/description>(.*)/) {
		$showDataKey = $showDataKey . "1";
		$showDataString = $showDataString . $2 . "|";
	} else {
		$showDataKey = $showDataKey . "0";
		$showDataString = $showDataString . "|";
	}
	
	print DAT "$showDataKey|$showDataString\n";
	
#	if ($tempProgram =~ m/<program id='(.*)'>;<title>(.*)<\/title>;<subtitle>(.*)<\/subtitle>;<description>(.*)<\/description>/) {
#		print DAT "ptsd|$1|$2|$3|$4\n";
		#we have ptsd
#	} else {
#			if ($tempProgram =~ m/<program id='(.*)'>;<title>(.*)<\/title>;<subtitle>(.*)<\/subtitle>/) {
				#we have pts
				#print("pts\n");
#				print DAT "ptsx|$1|$2|$3|none\n";
				
#			} else {	
#			if ($tempProgram =~ m/<program id='(.*)'>;<title>(.*)<\/title>;<description>(.*)<\/description>/) {
				#we have ptd			
				#print("ptd\n");
#				print DAT "ptxd|$1|$2|none|$3\n";
#			} else {
#				if ($tempProgram =~ m/<program id='(.*)'>;<title>(.*)<\/title>/) { 
					#we just have pt
#					print DAT "ptxx|$1|$2|none|none\n";
					#print("pt\n");
#				} else {
					
					#FAILURE
#				}			
#			}
#		}
#	}
}

close DAT;

sub getTitle {
	#$fullLine = `cat titles.txt | grep $_[0]`;
	#if ($fullLine =~ m/(.*)<t>(.+)\n/){
	#	return $2;
	
	#}
	#return $fullLine;
	return $titleHash{$_[0]};
}

sub getChannelNumber {
  $channelId = $_[0];
  foreach(@channels) {
	$test = $_;	

  	if ($test =~ m/(\d+)(\D+)(\d+)/g) {
		if ($1 == $channelId) {
						
			return $3;
		}
	}
  }
  return 0;
}